{ BP compatible Strings unit

  Copyright (C) 1999-2003 Free Software Foundation, Inc.

  Author: Frank Heckenbach <frank@pascal.gnu.de>

  This file is part of GNU Pascal.

  GNU Pascal is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2, or (at your
  option) any later version.

  GNU Pascal is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with GNU Pascal; see the file COPYING. If not, write to the
  Free Software Foundation, 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.

  As a special exception, if you link this file with files compiled
  with a GNU compiler to produce an executable, this does not cause
  the resulting executable to be covered by the GNU General Public
  License. This exception does not however invalidate any other
  reasons why the executable file might be covered by the GNU
  General Public License. }

{$gnu-pascal,I-}
{$if __GPC_RELEASE__ < 20030303}
{$error This unit requires GPC release 20030303 or newer.}
{$endif}

unit Strings;

interface

uses GPC;

function  StrLen     (Src: CString): SizeType;                           external name '_p_CStringLength';
function  StrEnd     (Src: CString): CString;                            external name '_p_CStringEnd';
function  StrMove    (Dest, Source: CString; Count: SizeType): CString;  external name '_p_CStringMove';
function  StrCopy    (Dest, Source: CString): CString;                   external name '_p_CStringCopy';
function  StrECopy   (Dest, Source: CString): CString;                   external name '_p_CStringCopyEnd';
function  StrLCopy   (Dest, Source: CString; MaxLen: SizeType): CString; external name '_p_CStringLCopy';
function  StrPCopy   (Dest: CString; const Source: String): CString;     external name '_p_CStringCopyString';
function  StrCat     (Dest, Source: CString): CString;                   external name '_p_CStringCat';
function  StrLCat    (Dest, Source: CString; MaxLen: SizeType): CString; external name '_p_CStringLCat';
function  StrComp    (s1, s2: CString): Integer;                         external name '_p_CStringComp';
function  StrIComp   (s1, s2: CString): Integer;                         external name '_p_CStringCaseComp';
function  StrLComp   (s1, s2: CString; MaxLen: SizeType): Integer;       external name '_p_CStringLComp';
function  StrLIComp  (s1, s2: CString; MaxLen: SizeType): Integer;       external name '_p_CStringLCaseComp';
function  StrScan    (Src: CString; ch: Char): CString;                  external name '_p_CStringChPos';
function  StrRScan   (Src: CString; ch: Char): CString;                  external name '_p_CStringLastChPos';
function  StrPos     (aString, SubString: CString): CString;             external name '_p_CStringPos';
function  StrRPos    (aString, SubString: CString): CString;             external name '_p_CStringLastPos';
function  StrUpper   (s: CString): CString;                              external name '_p_CStringUpCase';
function  StrLower   (s: CString): CString;                              external name '_p_CStringLoCase';
function  StrPas     (aString: CString): TString;                        attribute (name = '_p_StrPas');
function  StrEmpty   (s: CString): Boolean;                              external name '_p_CStringIsEmpty';
function  StrNew     (Src: CString): CString;                            external name '_p_CStringNew';
procedure StrDispose (s: CString);                                       external name '_p_Dispose';

implementation

function StrPas (aString: CString): TString;
begin
  StrPas := CString2String (aString)
end;

end.
